'' =================================================================================================
''            ************** Testing Logging Data at Random intervals **********************
''                                           
''
''             ***** LCD Displays - RPM and Inspiratory/Expiratory pressure settings  ****
''
''            ##### Inspiratory and Expiratory opening presures now can be set on thd fly #######
''            
''
''         *** Added Set pause time - with variable "PauseTime" with "PinH PinL" - earlier used only to set pressure limis ***       
''
''                          4 COG VERSION LAST MODIFIED ON 3/3/14  ----> RPM - 1200 
''
''           ## Vacuum pump connected to P14 ans suction from pump controlled by solenoid and Manually ###
''
''                     NOW USES 4 COGS AND VACUUM PUMP TO FACILITATE EXPIRATION
''
''              
''                     
''                         ***  TESTED the Logger does not write data to the file ********
''
con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000

  REFRESH_RATE = 16_000_000' 80_000_000/5                               
  

con

  SCL    = 28             'I2C connections to pressure sensor - MS4515DO
  SDA    = 29                                                                                  
  id     = $51            'Device Read address  ---->provided by OEM

  data   = 13             'data in pin to pin 1 of MAX-7219
  clock  = 11             'clock signal in pin to pin 13 of MAX-7219
  load   = 12             'load pulse in pin to pin 12 of MAX-7219
  DP     = %10000000      'decimal point 
  minus  = %1010          'MAX-7219 display code for a minus (-).

  rxpin     = 19             'Receive pin on the Propeller   ---> Datalogger
  txpin     = 18             'Transmit pin on the Propeller
  ctspin    = 17

  'LED                  = 7      'PIN# for RED & GREEN  LED
  PinL                 = 2      'PIN# for setting LOW Limits
  PinH                 = 3      'Pin# for setting HIGH limits
  PinIn                = 4      'Pin# to choose Inapiratory Limit settings
  PinEx                = 5       'Pin# to choose Expiratory Limit settings
  RevPin               = 6
  Baud                 = 19200
  Lines                = 4
  INPIN                = 8      'RPM counter PIN from BLDC controller
  MotorPin             = 1      'Motor run/stop
  ExpSolenoid1         = 23     'Exhalation circuit solenoid  connected tp P 23 ---> also the pressure relief valve 1
  ExpSolenoid2         = 22     'Exhalation circuit solenoid connected to P 22 ----> also the pressure relief valve 2
  IntakeSolenoids      = 21      'Opens in inspiration and closes during expiration
  VacPump              = 14     'Vacuum pump connected to P 14
  
obj

    I2C : "pasm_i2c_driver"
   Revs : "Debug_Lcd"       
   Seg_7: "7_Seg_LED.Driver_V1.3"
    USB : "Edited_Autodatalogger_Neg_Num"
  serial : "fullduplexserial"
    pst : "Parallax Serial Terminal"                   
var
     
     long  SetlimitsStack[150]
     long  RevCounterStack[100]
     long  DisplayStack[100]
     long  ControlStack[100]
     long  DataLoggerStack[100] 
     long  waitUntil, inFreq
     long  RPM 
     long  Insp, Exp, PauseTime
     long  pressure, pressure1
     long  filenameaddr
     long  num0, num1, num2, num3
     long  index 
     
pub main

   I2C.Initialize(SCL)                          ' setup I2C buss (boot pins)
   Revs.init(REVpin, baud, lines)               ' start Serial_LCD
   Seg_7.Start(12,11,13)                        'start 7 seg driver
   pause(10)

   cognew(SetLimits,@SetLimitsStack)
   cognew(DataLogger,@DataLoggerStack)                                               
   cognew(Revolution_Counter,@RevCounterStack)
   cognew(ValveControl,@ControlStack)
    
   Read_Display_Pressure
  
  
Pub Read_Display_Pressure              'READ AND DISPLAY PRESSURE ON THE 8 SEGMENT led DISPLAY
  
  repeat
    Seg_7.Clear(data,clock,load)              'Clear all digits - 7SegLED display
    
              'read I2C
    I2C.Start(SCL)
    I2C.Write(SCL,$51)                        'write read address
    Pressure := I2C.Read(SCL,1)                  'read pressure value to variable "Value"
    Pressure1:= Pressure-31                          ' Error correction(31)on initial reading at atmospheric pressure

     Seg_7.CharOut(data,clock,load,Pressure1)      'send pressure data to 7Seg.LED
     'Seg_7.CharOutLast(Data,clock,Load,Exp)   'send Expiratory setting
     'Seg_7.CharOutLast(Data,clock,Load,Insp) 
     pause(50)
     
  
Pub ValveControl                           'CONTROL SOLENOID VALVES DURING INSPIRATORY & EXPIRATORY PHASE

    dira[21..23]~~                         'Set solenoid pins as outputs
    dira[14]~~
    outa[23]~~                             'bypass solinoId is made open to avoid pressure issues from pump relief pressure
                                           'avoid back pressure as there will be NO out let if this solenoid is closed.
    pause(10)
    dira[MotorPin]~~
    pause(10)
    outa[MotorPin]~                       'Start BLDC motor

    PauseTime:=0

  Repeat                                     'Valve CONTROL CODE

     If  Pressure1 < Insp
        outa[21]~~            'Inspiratory Valves open between HIGH and LOW  pressures
        outa[22]~
        outa[23]~
        outa[14]~             'Inspiratory phase Pump valve open/bypass valve closed and expiratory valves close 
        pause(PauseTime)
        
     elseif Pressure1 => Exp
         outa[21]~              'Expiratory  Valves open between HIGH and LOW  pressures      
         outa[22]~~                   ' Expiratory phase ---> pump valve closes/bypass valve opens.
         outa[23]~~
        outa[14]~~                    'BOTH Relief valves @22&23 open
        pause(PauseTime)
        
    If Pressure1 > 15             'In case of inadvertant pressure rises > 12cm.H2O - pump is bypassed and
        outa[21]~
        outa[22..23]~~
        outa[14]~~                 ' both pressure relief valves open to AIR
        pause(1000)       
  
Pub DataLogger                             'DATA LOGGER CODE
 
  filenameaddr := string("Pressure.txt")
  num1 := num2 := num3 := 0

  waitcnt(clkfreq*6 + cnt)

  waitcnt(clkfreq*2 + cnt)

  USB.init(rxpin, txpin, ctspin, filenameaddr, 10_000)
 'Changes made by Korneko to log -ve numbers
 
 ' USB.addfield(     @num0, 10, string("fixed width unsigned"))
 ' USB.addfield(NEGX|@num1, 10, string("fixed width signed"))
 ' USB.addfield(     @num2,  0, string("auto width unsigned"))
 ' USB.addfield(NEGX|@num3,  0, string("auto width signed"))

     '(address, digits, title) 
  USB.addfield(@pressure, 2, string("Raw"))
  USB.addfield(@RPM, 4, string("RPM"))
  USB.addfield(@Pressure1, 2, string("corrected"))

  USB.start
  
  repeat num0 from 1 to 2
    num0[num0] := 3_999_999_999

  num0 := cnt 

  repeat 1
    
    repeat 60                 '1 Minute
      
      waitcnt(num0 += clkfreq)  'Seconds
     
  USB.stop

  repeat
    log_start                                           ' start log
             
    delay(3)                                            ' for 3 sec
             
    log_stop                                            ' stop
    log_stop                                            ' redundant but shouldn't break
             
    delay(2)                                            ' take a break
             
    log_start                                           ' start again
             
    delay(5)                                            ' for 5 sec
             
    log_stop                                            ' stop
             
    delay(4)                                            ' repeat after break
  
PRI delay(sec) : t

  t := cnt
  repeat sec
    waitcnt(t += clkfreq/2)
    !outa[17]
    waitcnt(t += clkfreq/2)
    !outa[17]
    
PRI log_start : n

  repeat 8
    name[n++] := lookupz((index <-= 4) & $F : "0".."9", "A".."F")
  index++
  
  serial.str(@name{0})                                  ' |
  serial.tx(13)                                         ' debug only
  
  USB.init(0, 1, 2, @name{0}, 10_000)
  USB.addfield(0, 0, 0)
  USB.addfield(0, 0, 0)
  USB.start

                                                   
Pub SetLimits   

      PauseTime:= 0  
      Insp:=-1
      Exp:= 3
                                             
    dira[pinIn]~~
    dira[pinH]~~  
    dira[pinEX]~~ 
    dira[pinL]~~ 

                  'Inapiration ans Expiration valve opening and closing pressure settings - variables "Insp & EXP" 

     Repeat
        if ina[PinIn]== 1  and  ina[PinH] == 1
          Insp++
        elseIf ina[pinIn]==1 and ina[PinL]==1    
            Insp--
            
        if ina[PinEx]== 1 and ina[PinH]==1
          Exp++
        elseif ina[PinEx]==1 and ina[PinL]== 1    
            Exp--
                    'Pause(Value) -value variable "PauseTime" setting
       
        If ina[PinH] ==1 and ina[PinIn]==0 and ina[PinEx]==0
           PauseTime++
           pauseTime <#= 300
        If ina[PinL]==1 and  ina[PinIn]==0 and ina[PinEx]==0

          pauseTime--
           pauseTime #>= 0


 

Pub Revolution_Counter

   Revs.backLight(true)                                  
   Revs.cursor(0) 

  ctra := %01010 << 26 + INPIN    ' counter A in POSedge mode
  frqa := 1                       ' increment 1 per pulse  waitcnt(clkfreq + cnt)

' measure the input duty cycle using counters.
  waitUntil := cnt + REFRESH_RATE
  repeat
    phsa := 0                     ' reset count registers
    waitcnt(waitUntil+=REFRESH_RATE)
    inFreq := phsa * (constant(80_000_000/REFRESH_RATE))         ' read the number of edges; convert to 1 second
    RPM:=(15*inFreq)
      
                  'LCD Display
        Revs.Home 
        Revs.str(string("RPM :"))
        Revs.dec(RPM)
        Revs.putc(13)
         Revs.str(string("   VALVE SETTINGS"))
        Revs.putc(13)  
        Revs.str(string("Ins-Phase:")) 
        Revs.gotoxy(10,2)
         Revs.str(string("     "))
         Revs.gotoxy(10,2) 
        Revs.dec(Insp)
        Revs.putc(13)
        Revs.str(string("Exp-Phase:"))
        Revs.gotoxy(10,3)
        Revs.str(string("     "))
        Revs.gotoxy(10,3)
        Revs.dec(Exp)
   
        waitcnt(clkfreq/10+cnt)

        'Pst Debug
     pst.Clear  
       pst.str(string("Insp-Phase:")) 
       pst.dec(Insp)
       pst.Char(13)
       pst.str(string("Exp-Phase:"))
       pst.dec(Exp)
     
pub pause(ms) | t

'' Delay program in milliseconds

  t := cnt - 1088                              ' sync with system counter
  repeat (ms #> 0)
    waitcnt(t += MS_001)



PRI Hold(sec) : t

  t := cnt
  repeat sec
    waitcnt(t += clkfreq/2)
    !outa[17]
    waitcnt(t += clkfreq/2)
    !outa[17]
    
PRI log_begin : n                                        'changed to Begin

  repeat 8
    name[n++] := lookupz((index <-= 4) & $F : "0".."9", "A".."F")
  index++
  
  serial.str(@name{0})                                  ' |
  serial.tx(13)                                         ' debug only
  
  USB.init(0, 1, 2, @name{0}, 10_000)
  USB.addfield(0, 0, 0)
  USB.addfield(0, 0, 0)
  USB.start

PRI log_stop

    USB.stop
    
DAT

name    byte    "00000000.log", 0

 
dat

{{

  Copyright (c) 2009-10 Jon McPhalen (aka Jon Williams)

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

            
    
     Autodataloggeer V 1.0 -  - By SRLM   TERMS OF USE: MIT License                                                                                              
     
     Permission is hereby granted, free of charge, to any person obtaining a copy of this  
     software and associated documentation files (the "Software"), to deal in the Software  
     without restriction, including without limitation the rights to use, copy, modify,    
     merge, publish, distribute, sublicense, and/or sell copies of the Software, and to    
     permit persons to whom the Software is furnished to do so, subject to the following   
     conditions:                                                                                                                       
                                                                                                                                          
     The above copyright notice and this permission notice shall be included in all copies 
     or substantial portions of the Software.                                              
                                                                                                                                           
     THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,   
     INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A         
     PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT    
     HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION     
     OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE        
     SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                                
     



}}

                   